/*======================================================================*/
/*        Rrpn.exf for Ruputer Ver 0.01                                 */
/*        Coded by sigNgwNg                                             */
/*        main_with_덷.c version                                      */
/*======================================================================*/

#include <psdos.h>
#include <lcdbios.h>
#include <wbios.h>
#include <rupsys.h>
#include <font.h>
#include "math.h"
#include "dispbtn.h"
#include "swn.h"
#include "swenter.h"
#include "dpusage.h"

#define MAXOP 11
#define MAXVAL 20
#define PI M_PI

int sp=0;
int val1[MAXVAL];
double val2[MAXVAL];

int showusage(void);
void push1(int);
void push2(double);
int pop1(void);
double pop2(void);
void dpint(double);
int mkint(double);
double mkpoint(double);
void dphex(int);
int pof = 0;
int f2 = 0;

int cnstf = 1;

/* OtBbNGA̓o^ */
const RECT CLRLCD={0,0,101,63};

/* j[ݒ */

static MENU menuLIST[]={
 { setExitMenu,	"EXIT       I ",0,0},
 { showusage,	"Usage    gp@ ",0,0}
};

/* t擾p */
/*static WatchDT MDTime;*/

int showusage(void) {
 int btn; /* {^ */

 lcdfreeze(1);
 pv_clear((RECT *)&CLRLCD);
 gv_put(0,0, (char *)dpusage,0);
 lcdfreeze(0);

 btn = Keyin(0,0);

 while (1) {
  lcdfreeze(1);
  gv_put(0,0, (char *)dpusage,0);
  lcdfreeze(0);

  while (1) {
   btn = Keyin(0,0);
   if (btn & Bkey_B) {
   return -4;
   }
  }
 }
}

void dpint(double pp)
{
 int i;
 char s[MAXOP];
 int v;
 int n = 1;
 int pint;
 double ppoint;
 pint=mkint(pp);
 ppoint=mkpoint(pp);
 v=(int)pp;

 if (fabs(pp)<32768.0) { /* 32767.99 */
  while ( abs(v) >= 10) {
   (int)v /= 10;
   n++;
  }
  for (i=0;i<6;i++) {
   s[i]=' ';
  }
  for (i=7;i<11;i++) {
   s[i]=0;
  }
  s[9]='\0';

  if ( pp >= 0) {
/* fors */
   s[10-2] = (int)ppoint % 10 + 0x30;
   ppoint /= 10;
   s[10-3] = (int)ppoint % 10 + 0x30;
/* s[10-1] = (int)vdouble % 10 + 0x30;*/ /* 덷  傫 */
   s[6]='.';
   v = pint;
   for (i=1;i<=n;i++) {
    s[10-i-4] = 0x30 + (int)v % 10;
    v /= 10;
   }
  } else if (pp < 0) {  /*  _ȉ NG */
   s[10-2] = 0x30 - (int)ppoint % 10;
   ppoint /= 10;
   s[10-3] = 0x30 - (int)ppoint % 10;
   s[10-3-1]='.';
   v = pint;
   for (i=1;i<=n;i++) {
/*  s[10-i-4] = 0x30 - (unsigned int)v % 10 +0x06 ; */  /* unsigned   NG */
    s[10-i-4] = 0x30 - (int)v % 10;
    v /= 10;
   }
   s[0]='-';
  } else {
   gv_kput( 20, 3, "n" , 1 , 0 , 0); /* debug */
  }
  gv_kput( 0, 3 , s , 1 , 4 , 0); /* debug */
 } else {
  s[0]='o';
  s[1]='v';
  s[2]='e';
  s[3]='r';
  s[4]=' ';
  s[5]='f';
  s[6]='l';
  s[7]='o';
  s[8]='w';
  s[9]='\0';
  gv_kput( 10, 3 , s , 1 , 4 , 0);
 }
}

void dphex(int vah) /* debug */
{
 int i;
 char s[MAXOP];
 int vh = vah;
 int n = 1;

 while ( abs(vh) >= 16.0) {
  vh /= 16;
  n++;
 }
 for (i=0;i<10;i++) {
  s[i]=' ';
 }
 vh = vah;
 for (i=1;i<=n;i++) {
  if (vh % 16 > 9) {
   s[10-i-4] = 0x37 + vh % 16;
  } else {
   s[10-i-4] = 0x30 + vh % 16;
  }
  vh /= 16;
 }
 s[9] = '\0';
 gv_kput( 0, 3 , s , 1 , 4 , 0); /* debug */
}

int mkint(double pp){
 int pint;
 pint=(int)pp;
 return pint;
}

double  mkpoint(double pp){
 double ppoint;
 ppoint=(pp-(int)pp)*100;
 return ppoint;
}

void push1(int e)
{
 if (sp<MAXVAL)
  val1[sp]=e;
 else
/*  cout << "error: stack fll,can't push %g" << f << endl;*/
  gv_kput( 20, 3, "e" , 1 , 0 , 0);
}

void push2(double f)
{
 if (sp<MAXVAL) {
  val2[sp]=f;
  sp++;
 } else {
/*  cout << "error: stack fll,can't push %g" << f << endl;*/
  gv_kput( 20, 3, "e" , 1 , 0 , 0);
 }
}

int pop1(void)
{
 if (sp>=0) {
  sp--;
  return val1[sp];
 } else {
/*  cout << "error: stack empty" << endl;*/
  gv_kput( 20, 3, "e" , 1 , 0 , 0);
  return 0;
 }
}

double pop2(void)
{
 if (sp>=0)
  return val2[sp];
 else {
/*  cout << "error: stack empty" << endl;*/
  gv_kput( 20, 3, "e" , 1 , 0 , 0);
  return 0;
 }
}


/*-----------------------------------------------------------*/
/*       C                                              */
/*-----------------------------------------------------------*/
int main(void)
{

 /* OtBbNGA̓o^ */
 const RECT CLRLCD={0,0,101,63};

 int i;
 int c;
 double op1,op2;
 char s[MAXOP];
 double opn[30];

 int menuEND = 0;
 int bt;           /* {^ */
 int sw = 0;
 int numbf = 0;
 int arcf = 0;
 int hpf = 0;
 double pp = 0.0;
 int n = 1;
 double v;
 double sg1,sg2;
 int pint = 0;
 double ppoint = 0.0;
 int f2 = 0;
 char di[2];

    /* start */

    /* OtBbN[hɐݒ */    
    screen(1); 

    /* 320200̂ǂ\邩  X:0,Y:0 */
    gv_place(0,0);

    /* kbcʃt[Y */
    lcdfreeze(1);

    /* ʃNA */
    pv_clear((RECT *)&CLRLCD);       

    /* kbcʃt[Y */
    lcdfreeze(0);

    /* NAj̒~  */
    endWaiting();                   

    /* kbcʃt[Y */
    lcdfreeze(1);

    /* ʃNA */
    pv_clear((RECT *)&CLRLCD);

    gv_put( 0, 0, dispbtn, 0);
    dpint(pp);
    /* kbcʃt[Y */
    lcdfreeze(0);

 while(1) /* [vJn */
 {
  bt = Keyin( 0,0 );

		if( bt & Bkey_D ){ /* Menu key */
			menuEND = aprMenu("Menu",menuLIST,
							(int)sizeof(menuLIST)/sizeof(MENU));
			if( menuEND == -2 )	dos_exit(0);	/* ع݂̏I	*/
		} else if (sw == 0) {
			gv_put( 0, 0, dispbtn, 0);
			dpint(pp);
			if (bt & Bkey_lf) {
				sw = 1;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 19, swn[0], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 10;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 19, swn[9], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 1;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 19, swn[0], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 30;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 52, swn[29], 0) ;
				dpint(pp);
			}
		} else if (sw == 1) {
			if (bt & Bkey_lf) {
				sw = 10;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 19, swn[9], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 2;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 19, swn[1], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 30;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 52, swn[29], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 11;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 30, swn[10], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(sin(pop())); */
				if ( arcf == 0 && hpf == 0) {
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=sin(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if ( arcf == 1 && hpf == 0 ) {
					gv_put( 32, 19, swn[3], 0) ;
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=asin(pop1()+pop2()/100.0);
					dpint(pp);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if ( hpf == 1 && arcf == 0 ) {
					gv_put( 42, 19, swn[4], 0) ;
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=sinh(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if ( hpf == 1 && arcf == 1 ) {
					gv_put( 32, 19, swn[3], 0) ;
					gv_put( 42, 19, swn[4], 0) ;
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=asinh(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				}
			}
		} else if (sw == 2) {
			if (bt & Bkey_lf) {
				sw = 1;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 19, swn[0], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 3;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 19, swn[2], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 31;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 52, swn[30], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 12;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 30, swn[11], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(cos(pop()));*/
				if ( arcf == 0 && hpf == 0) {
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=cos(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if ( arcf == 1 ) {
					gv_put( 32, 19, swn[3], 0) ;
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=acos(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if ( hpf == 1 ) {
					gv_put( 42, 19, swn[4], 0) ;
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=cosh(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				}
			}
		} else if (sw == 3) {
			if (bt & Bkey_lf) {
				sw = 2;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 19, swn[1], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 4;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 19, swn[3], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 32;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 52, swn[31], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 13;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 30, swn[12], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(tan(pop()));*/
				if ( arcf == 0 && hpf == 0) {
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=tan(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if ( arcf == 1 ) {
					gv_put( 32, 19, swn[3], 0) ;
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=atan(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if ( hpf == 1 ) {
					gv_put( 42, 19, swn[4], 0) ;
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=tanh(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				}
			}
		} else if (sw == 4) {
			if (bt & Bkey_lf) {
				sw = 3;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 19, swn[2], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 5;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 19, swn[4], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 33;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 52, swn[32], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 14;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 30, swn[13], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				numbf = 0;
				arcf = 1;
				gv_put( 32, 19, swn[3], 0) ;
			}
		} else if (sw == 5) {
			if (bt & Bkey_lf) {
				sw = 4;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 19, swn[3], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 6;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 19, swn[5], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 34;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 52, swn[33], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 15;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 30, swn[14], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
					numbf = 0;
					hpf = 1;
					gv_put( 42, 19, swn[4], 0) ;
			}
		} else if (sw == 6) {
			if (bt & Bkey_lf) {
				sw = 5;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 19, swn[4], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 7;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 19, swn[6], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 40;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 41, swenter, 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 16;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 30, swn[15], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=-1.0*(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
			}
		} else if (sw == 7) {
			if (bt & Bkey_lf) {
				sw = 6;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 19, swn[5], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 8;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 19, swn[7], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 35;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 52, swn[34], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 18;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 30, swn[17], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(7);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 7.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+7.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0)+7.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 8) {
			if (bt & Bkey_lf) {
				sw = 7;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 19, swn[6], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 9;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 19, swn[8], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 36;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 52, swn[35], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 17;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 30, swn[16], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(8);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 8.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+8.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0)+8.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 9) {
			if (bt & Bkey_lf) {
				sw = 8;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 19, swn[7], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 10;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 19, swn[9], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 37;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 52, swn[36], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 19;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 30, swn[18], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(9);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 9.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+9.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0)+9.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 10) {
			if (bt & Bkey_lf) {
				sw = 9;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 19, swn[8], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 1;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 19, swn[0], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 38;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 52, swn[37], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 20;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 30, swn[19], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				op2=pop1()+pop2()/100.0;
				if (op2 != 0.0) {
/*					push(pop() / op2);*/
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pof = 0;
					pp= (pop1()+pop2()/100.0) / op2;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else
					/* cout << "error: zero divisor" << endl;*/
					gv_kput( 20, 3, "e" , 1 , 0 , 0);
			}
		} else if (sw == 11) {
			if (bt & Bkey_lf) {
				sw = 20;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 30, swn[19], 0) ;
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 12;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 30, swn[11], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 1;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 19, swn[0], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 21;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 41, swn[20], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				op2=pop1()+pop2()/100.0;
/*				push(pow(pop(),op2));*/
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pp=pow((pop1()+pop2()/100.0),op2);
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 12) {
			if (bt & Bkey_lf) {
				sw = 11;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 30, swn[10], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 13;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 30, swn[12], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 2;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 19, swn[1], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 22;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 41, swn[21], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(1 / (pop()));*/
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pp= 1.0 / (pop1()+pop2()/100.0);
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 13) {
			if (bt & Bkey_lf) {
				sw = 12;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 30, swn[11], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 14;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 30, swn[13], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 3;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 19, swn[2], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 23;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 41, swn[22], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(log10(pop()));*/
				op2=pop1()+pop2()/100.0;
				if (op2 != 0.0) {
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp=log10(op2);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else
					/* cout << "error: zero divisor" << endl;*/
					gv_kput( 20, 3, "e" , 1 , 0 , 0);
			}
		} else if (sw == 14) {
			if (bt & Bkey_lf) {
				sw = 13;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 30, swn[12], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 15;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 30, swn[14], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 4;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 19, swn[3], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 24;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 41, swn[23], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				/* sigma */
/*				sqrt((n*(pow(pop(),2)+...)-pow(pop()+...,2))/n/(n-1)) */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				n = (pop1()+pop2()/100.0);
				for (i=0;i<n;i++) {
					opn[i]=(pop1()+pop2()/100.0);
					sg1=sg1+pow(opn[i],2);
					sg2=sg2+opn[i];
				}
				pp=sqrt((n*sg1-pow(sg2,2))/n/(n-1));
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 15) {
			if (bt & Bkey_lf) {
				sw = 14;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 30, swn[13], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 16;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 30, swn[15], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 5;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 19, swn[4], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 25;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 41, swn[24], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				/* DEC2HEX */ /* size over = 63.9KB ̈,ꎞ cut */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 30, swn[14], 0) ;
				dphex(pop1()+pop2()/100.0);
				f2 = 0;
			}
		} else if (sw == 16) {
			if (bt & Bkey_lf) {
				sw = 15;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 30, swn[14], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 18;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 30, swn[17], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 6;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 19, swn[5], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 39;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 41, swenter, 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				op2=(pop1()+pop2()/100.0);
				if (op2!=0.0) {
/*					push(fmod(pop(),op2));*/
					pp=fmod((pop1()+pop2()/100.0),op2);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else
					/* cout << "error: zero divisor" << endl; */
					gv_kput( 20, 3, "e" , 1 , 0 , 0);
			}
		} else if (sw == 18) {
			if (bt & Bkey_lf) {
				sw = 16;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 30, swn[15], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 17;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 30, swn[16], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 7;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 19, swn[6], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 26;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 41, swn[25], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(4);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 4.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+4.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0)+4.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 17) {
			if (bt & Bkey_lf) {
				sw = 18;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 30, swn[17], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 19;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 30, swn[18], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 8;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 19, swn[7], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 27;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 41, swn[26], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(5);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 5.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+5.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0) + 5.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 19) {
			if (bt & Bkey_lf) {
				sw = 17;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 30, swn[16], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 20;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 30, swn[19], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 9;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 19, swn[8], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 28;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 41, swn[27], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(6);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 6.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+6.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0) + 6.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 20) {
			if (bt & Bkey_lf) {
				sw = 19;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 30, swn[18], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 11;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 30, swn[10], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 10;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 19, swn[9], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 29;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 41, swn[28], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(pop()*pop());*/
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pof = 0;
				pp= (pop1()+pop2()/100.0)*(pop1()+pop2()/100.0);
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 21) {
			if (bt & Bkey_lf) {
				sw = 29;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 41, swn[28], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 22;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 41, swn[21], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 11;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 30, swn[10], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 30;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 52, swn[29], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(sqrt(pop()));*/
				numbf = 0;
				arcf = 0;
				hpf = 0;
				op2=pop1()+pop2()/100.0;
				if (op2 < 0.0) {
					di[0]=0x69; /* Pi(̂) */
					di[1]='\0';
					gv_kput( 90, 3, di , 1 , 0 , 0);
					op2=fabs(op2);
				}
				pp= sqrt(op2);
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 22) {
			if (bt & Bkey_lf) {
				sw = 21;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 41, swn[20], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 23;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 41, swn[22], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 12;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 30, swn[11], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 31;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 52, swn[30], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(exp(pop()));*/
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pp= exp(pop1()+pop2()/100.0);
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 23) {
			if (bt & Bkey_lf) {
				sw = 22;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 41, swn[21], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 24;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 41, swn[23], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 13;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 30, swn[12], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 32;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 52, swn[31], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(log(pop()));*/
				op2=pop1()+pop2()/100.0;
				if (op2 != 0.0) {
					numbf = 0;
					arcf = 0;
					hpf = 0;
					pp= log(op2);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else
					/* cout << "error: zero divisor" << endl;*/
					gv_kput( 20, 3, "e" , 1 , 0 , 0);
			}
		} else if (sw == 24) {
			if (bt & Bkey_lf) {
				sw = 23;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 41, swn[22], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 25;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 41, swn[24], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 14;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 30, swn[13], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 33;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 52, swn[32], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				/* ! kaijyou */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pp=(pop1()+pop2()/100.0);
				for (i=pp-1;i>0;i--) {pp = pp * i;}
				if (pp==0.0) pp=1.0;
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 25) {
			if (bt & Bkey_lf) {
				sw = 24;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 41, swn[23], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 39;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 41, swenter, 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 15;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 30, swn[14], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 34;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 52, swn[33], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(PI);*/
				numbf = 0;
				arcf = 0;
				hpf = 0;
				if (f2==0) {
					pp= PI;
				} else if (f2==1) {
					gv_put( 0, 0, dispbtn, 0);
					gv_put( 42, 41, swn[24], 0) ;
					gv_put( 12, 52, swn[30], 0) ;
					pp=M_E;
					f2=0;
				}
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 26) {
			if (bt & Bkey_lf) {
				sw = 39;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 41, swenter, 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 27;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 41, swn[26], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 18;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 30, swn[17], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 35;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 52, swn[34], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(1);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 1.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+1.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0) + 1.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 27) {
			if (bt & Bkey_lf) {
				sw = 26;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 41, swn[25], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 28;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 41, swn[27], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 17;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 30, swn[16], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 36;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 52, swn[35], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 2.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+2.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0) + 2.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 28) {
			if (bt & Bkey_lf) {
				sw = 27;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 41, swn[26], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 29;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 41, swn[28], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 19;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 30, swn[18], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 37;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 52, swn[36], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(3);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 3.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+3.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
					pp=(pop1()+pop2()/100.0)+3.0 / pow(10.0,pof);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 29) {
			if (bt & Bkey_lf) {
				sw = 28;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 41, swn[27], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 21;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 41, swn[20], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 20;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 30, swn[19], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 38;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 52, swn[37], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pof = 0;
				op2=(pop1()+pop2()/100.0);
				pp=(pop1()+pop2()/100.0)-op2;
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 30) {
			if (bt & Bkey_lf) {
				sw = 38;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 52, swn[37], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 31;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 52, swn[30], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 21;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 41, swn[20], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 1;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 19, swn[0], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				dos_exit(0);	/* ع݂̏I	*/
			}
		} else if (sw == 31) {
			if (bt & Bkey_lf) {
				sw = 30;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 52, swn[29], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 32;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 52, swn[31], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 22;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 41, swn[21], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 2;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 19, swn[1], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				/* 2nd function */
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 52, swn[30], 0) ;
				f2=1;
			}
		} else if (sw == 32) {
			if (bt & Bkey_lf) {
				sw = 31;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 12, 52, swn[30], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 33;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 52, swn[32], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 23;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 41, swn[22], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 3;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 19, swn[2], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				/* clear */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pof = 0;
				pp=0.0;
				gv_put( 0, 0, dispbtn, 0);
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 33) {
			if (bt & Bkey_lf) {
				sw = 32;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 22, 52, swn[31], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 34;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 52, swn[33], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 24;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 41, swn[23], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 4;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 19, swn[3], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				/* sto */
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 34) {
			if (bt & Bkey_lf) {
				sw = 33;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 32, 52, swn[32], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 40;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 41, swenter, 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 25;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 41, swn[24], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 5;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 19, swn[4], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				/* rcl */
				pp=(pop1()+pop2()/100.0);
				dpint(pp);
			}
		} else if (sw == 35) {
			if (bt & Bkey_lf) {
				sw = 40;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 41, swenter, 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 36;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 52, swn[35], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 26;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 41, swn[25], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 7;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 19, swn[6], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				push(0);*/
				if (numbf==0) {
					numbf =1;
					arcf = 0;
					hpf = 0;
					pp = 0.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof == 0 && numbf<=2) {
					numbf ++;
					arcf = 0;
					hpf = 0;
					pp=10.0*(pop1()+pop2()/100.0)+0.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
				} else if (pof > 0 && pof <= 3) {
					numbf = 1;
					arcf = 0;
					hpf = 0;
/*					pp=pop()+0.0 / pow(10.0,pof);*/
					pp=(pop1()+pop2()/100.0);
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
					pof++;
				} else if ( pof > 3 || numbf > 2 ) {
					;
				}
			}
		} else if (sw == 36) {
			if (bt & Bkey_lf) {
				sw = 35;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 52, swn[34], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 37;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 52, swn[36], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 27;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 41, swn[26], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 8;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 19, swn[7], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
/*				if (c=='.')*/
				if (numbf == 0) {
					pp = 0.0;
					dpint(pp);
				} else if (numbf>0) {
					pp=(pop1()+pop2()/100.0)+0.0;
					dpint(pp);
				}
				numbf = 1;
				arcf = 0;
				hpf = 0;
				pof = 1;
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 37) {
			if (bt & Bkey_lf) {
				sw = 36;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 71, 52, swn[35], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 38;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 52, swn[37], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 28;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 41, swn[27], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 9;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 19, swn[8], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				/* sum + or - */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pp=(pop1()+pop2()/100.0);
				if (pp > 0) {
					for (i=pp-1;i>0;i--) {pp = pp + i;}
				} else if (pp < 0.0) {
					for (i=pp+1;i<0;i++) {pp = pp + i;}
				} else if (pp==0.0) pp=1.0;
					pint=mkint(pp);
					ppoint=mkpoint(pp);
					dpint(pp);
					push1(pint);
					push2(ppoint);
			}
		} else if (sw == 38) {
			if (bt & Bkey_lf) {
				sw = 37;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 81, 52, swn[36], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 30;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 2, 52, swn[29], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 29;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 41, swn[28], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 10;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 91, 19, swn[9], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pof=0;
				pof = 0;
				pp= (pop1()+pop2()/100.0) + (pop1()+pop2()/100.0);
				pint=mkint(pp);
				ppoint=mkpoint(pp);
				dpint(pp);
				push1(pint);
				push2(ppoint);
			}
		} else if (sw == 39) {
			if (bt & Bkey_lf) {
				sw = 25;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 41, swn[24], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 26;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 41, swn[25], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 16;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 30, swn[15], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 40;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 41, swenter, 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pof = 0;
			}
		} else if (sw == 40) {
			if (bt & Bkey_lf) {
				sw = 34;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 42, 52, swn[33], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_rg) {
				sw = 35;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 61, 52, swn[34], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_up) {
				sw = 39;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 41, swenter, 0) ;
				dpint(pp);
			}
			if (bt & Bkey_dw) {
				sw = 6;
				gv_put( 0, 0, dispbtn, 0);
				gv_put( 52, 19, swn[5], 0) ;
				dpint(pp);
			}
			if (bt & Bkey_B) { /* enter */
				numbf = 0;
				arcf = 0;
				hpf = 0;
				pof = 0;
			}
		} else {
			gv_kput( 10, 10, "a" , 1 , 0 , 0); /* debug */
		}
	}
}
